<template>
    <div>
        <router-link :to="{name:listRouteName}" class="title is-5">< Back to List</router-link>
        <div class="columns">
            <div class="column is-half-desktop is-offset-one-quarter-desktop">
                <h1 class="title" v-if="!isNew">{{ module }} {{ entityName }}</h1>
                <h1 class="title" v-else>Create New {{ module }}</h1>

                <transition name="slide-fade">
                    <p class="subtitle" v-if="initialLoad">Loading...</p>
                </transition>

                <article v-for="(e, index) in submitErrors" class="message is-danger">
                    <div class="message-header">
                        <p><strong>Error</strong></p>
                    </div>
                    <div class="message-body">{{ e.message }}</div>
                </article>

                <transition name="slide-fade">
                    <form v-if="!initialLoad" method="post" :action="postRoute" @submit.prevent="onSubmit" @keydown="form.errors.clear($event.target.name)">

                        <slot></slot>

                        <div class="columns">
                            <div class="column">
                                <transition name="slide-fade">
                                    <p class="is-success" v-if="showSuccess">{{ successMessage }}</p>
                                </transition>
                            </div>
                            <div class="column has-text-right">
                                <button class="button is-primary" type="submit" :class="{'is-loading':form.loading}" :disabled="!submittable">Save</button>
                            </div>
                        </div>
                    </form>
                </transition>
            </div>
        </div>
    </div>
</template>

<script>
    import axios from 'axios';
    import { Form } from './form';
    export default {
        props: {
            id: {
                required:true
            },
            listRouteName: {
                type:String,
                required:true
            },
            formRouteName: {
                type: String,
                required: true
            },
            module: String,
            entityName: String,
            successMessage: String,
            form: {
                type: Form,
                required: true
            },
            afterSubmit: Function,
            submittable: Boolean,
            getRoute: String,
            postRoute: String,
            putRoute: String
        },

        data() {
            return {
                showSuccess: false,
                initialLoad: false,
                loading: false,
                submitErrors: []
            }
        },
        computed: {
            isNew() {
                return this.id === 'create';
            }
        },
        methods: {
            onSubmit() {
                this.submitErrors = [];

                let promise = (this.isNew)
                    ? this.form.post(this.postRoute)
                    : this.form.put(this.putRoute);

                let that = this;

                promise.then((response) => {
                    this.afterSubmit(response);
                    this.$router.push({
                        name: this.formRouteName,
                        params: {id: response.id}
                    });
                    this.showSuccessMessage();
                }).catch((error) => {
                    that.submitErrors.push(error.data);
                });
            },
            showSuccessMessage() {
                this.showSuccess = true;
                setTimeout(() => this.showSuccess = false, 4000);
            }
        },
        created() {
            if(!this.isNew) {
                this.initialLoad = true;
                axios.get(this.getRoute)
                    .then((response) => {
                        this.afterSubmit(response.data);
                        this.loading = false;
                        this.initialLoad = false;
                    });
            }
        }
    }
</script>